## galera-26.4.9.tar.gz.52b29c5888257918ea4677ff440d5adc

=== CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

message(STATUS "CMake version ${CMAKE_VERSION}")
cmake_minimum_required(VERSION 2.8)
project(galera-4)

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckCXXCompilerFlag)
include(CheckLibraryExists)

include_directories(
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/common
  ${CMAKE_SOURCE_DIR}/galerautils/src
  ${CMAKE_SOURCE_DIR}/gcomm/src
  ${CMAKE_SOURCE_DIR}/gcache/src
  ${CMAKE_SOURCE_DIR}/gcs/src
  ${CMAKE_SOURCE_DIR}/wsrep/src
  )

# Options to control compiler options and error behavior.
option(GALERA_MAINTAINER_MODE "Fail compilation on warnings" OFF)

# Galera library options.
option(GALERA_WITH_SSL "Compile Galera with SSL" ON)
option(GALERA_VERSION_SCRIPT "Limit symbols visible from Galera DSO" ON)
option(GALERA_STATIC "Build statically linked binaries" OFF)
option(GALERA_SOURCE
  "Configure for source package only, skipping build configuration" OFF)

# Developer options and instrumentation.
option(GALERA_WITH_ASAN "Enable ASAN instrumentation" OFF)
option(GALERA_WITH_VALGRIND "Optionally run tests with valgrind" OFF)
option(GALERA_WITH_COVERAGE "Compile with coverage instrumentation" OFF)
option(GALERA_GCS_SM_DEBUG
  "Enable dumping of send monitor state and history" OFF)
option(GALERA_GU_DEBUG_MUTEX "Enable mutex debug instrumentation" OFF)
option(GALERA_GU_DBUG_ON "Enable sync point macros (ON for Debug builds)" OFF)

#
# Set cmake policies before doing any checks.
#

# In CMake 3.12 and above, the
#
# * ``check_include_file`` macro in the ``CheckIncludeFile`` module, the
# * ``check_include_file_cxx`` macro in the
#   ``CheckIncludeFileCXX`` module, and the
# * ``check_include_files`` macro in the ``CheckIncludeFiles`` module
#
# now prefer to link the check executable to the libraries listed in the
# ``CMAKE_REQUIRED_LIBRARIES`` variable.  This policy provides compatibility
# with projects that have not been updated to expect this behavior.
if (POLICY CMP0075)
  CMAKE_POLICY(SET CMP0075 OLD)
endif()

# Determine version first to have it near the top of build log.
include(cmake/version.cmake)
include(cmake/package.cmake)

# Do not execute other configuration steps if building source only.
if (GALERA_SOURCE)
  return()
endif()

# Source compiler/OS settings first as it sets used C/C++ standards,
# common compiler flags and include/link paths.
include(cmake/compiler.cmake)
include(cmake/os.cmake)
# Instrumentation.
include(cmake/asan.cmake)

# Common definitions for all modues.
include(cmake/common.cmake)

# Libraries, language library features.
include(cmake/ssl.cmake)
include(cmake/asio.cmake)
include(cmake/array.cmake)
include(cmake/boost.cmake)
include(cmake/crc32c.cmake)
include(cmake/endian.cmake)
include(cmake/shared_ptr.cmake)
include(cmake/unordered.cmake)
include(cmake/check.cmake)
include(cmake/memorycheck.cmake)
include(cmake/coverage.cmake)
# Keep the maintainer mode as last to avoid feature checks failing
# in compiler warnings.
include(cmake/maintainer_mode.cmake)

include(CTest)
enable_testing()
add_subdirectory(galerautils)
add_subdirectory(gcomm)
add_subdirectory(gcache)
add_subdirectory(gcs)
add_subdirectory(garb)
add_subdirectory(galera)
add_subdirectory(scripts/packages)
add_subdirectory(wsrep/tests)

if (NOT ${CMAKE_SYSTEM_NAME} MATCHES ".*BSD")
  install(FILES
    ${CMAKE_SOURCE_DIR}/AUTHORS
    ${CMAKE_SOURCE_DIR}/COPYING
    ${CMAKE_SOURCE_DIR}/README
    DESTINATION doc)
  install(FILES ${CMAKE_SOURCE_DIR}/asio/LICENSE_1_0.txt
    DESTINATION doc
    RENAME LICENSE.asio)
endif()

message(STATUS "")
message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
get_directory_property(DirDefs COMPILE_DEFINITIONS)
message(STATUS "COMPILE_DEFINITIONS: ${DirDefs}")
message(STATUS "CMAKE_C_FLAGS: ${CMAKE_C_FLAGS}")
message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
message(STATUS "CMAKE_EXE_LINKER_FLAGS: ${CMAKE_EXE_LINKER_FLAGS}")
message(STATUS "GALERA_SYSTEM_LIBS: ${GALERA_SYSTEM_LIBS}")
message(STATUS "GALERA_UNIT_TEST_LIBS: ${GALERA_UNIT_TEST_LIBS}")
message(STATUS "")

=== garb/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

add_executable(garbd
  garb_config.cpp
  garb_logger.cpp
  garb_gcs.cpp
  garb_recv_loop.cpp
  garb_main.cpp
  )

target_include_directories(garbd
  PRIVATE
  ${CMAKE_SOURCE_DIR}/wsrep/src
  )

target_compile_definitions(garbd
  PRIVATE
  -DGALERA_VER="${GALERA_VERSION}"
  -DGALERA_REV="${GALERA_REVISION}"
  )

# TODO: Fix.
target_compile_options(garbd
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  )

target_link_libraries(garbd gcs4garb gcomm gcache
  ${Boost_PROGRAM_OPTIONS_LIBRARIES})

install(TARGETS garbd DESTINATION bin)
if (NOT ${CMAKE_SYSTEM_NAME} MATCHES ".*BSD")
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/files/garb.cnf
    ${CMAKE_CURRENT_SOURCE_DIR}/files/garb.service
    ${CMAKE_CURRENT_SOURCE_DIR}/files/garb-systemd
    DESTINATION share)
  install(FILES
    ${CMAKE_SOURCE_DIR}/man/garbd.8
    DESTINATION man/man8)
endif()

=== galerautils/src/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

#
# Compile hardware optimized CRC32C code into separate library
# to keep the optimized code isolated.
#
if (GALERA_CRC32C_X86_64)
  set(GALERAUTILS_HW_CRC32C_SOURCES gu_crc32c_x86.c)
elseif (GALERA_CRC32C_ARM64)
  set(GALERAUTILS_HW_CRC32C_SOURCES gu_crc32c_arm64.c)
endif()

if (GALERAUTILS_HW_CRC32C_SOURCES)
  set(GALERAUTILS_HW_CRC32C_LIB galerautils_hw_crc32c)
  add_library(${GALERAUTILS_HW_CRC32C_LIB} ${GALERAUTILS_HW_CRC32C_SOURCES})
  target_compile_options(${GALERAUTILS_HW_CRC32C_LIB}
    PRIVATE
    ${GALERA_CRC32C_COMPILER_FLAG})
endif()

add_library(galerautils
  gu_abort.c
  gu_crc32c.c
  gu_dbug.c
  gu_fifo.c
  gu_lock_step.c
  gu_log.c
  gu_mem.c
  gu_mmh3.c
  gu_spooky.c
  gu_rand.c
  gu_threads.c
  gu_hexdump.c
  gu_to.c
  gu_utils.c
  gu_uuid.c
  gu_backtrace.c
  gu_limits.c
  gu_time.c
  gu_init.c
  )

# TODO: These should be eventually fixed:
# - Wno-unused-parameter
#
# Suppress -Wself-assign which may emit unwanted warnings when
# using byte swapping macros in way like k = gu_le64(k).
#
target_compile_options(galerautils
  PRIVATE
  -Wno-unused-parameter)

target_link_libraries(galerautils
  ${GALERAUTILS_HW_CRC32C_LIB}
  ${GALERA_SYSTEM_LIBS})

add_library(galerautilsxx
  gu_vlq.cpp
  gu_datetime.cpp
  gu_gtid.cpp
  gu_exception.cpp
  gu_hexdump.cpp
  gu_serialize.cpp
  gu_logger.cpp
  gu_regex.cpp
  gu_string_utils.cpp
  gu_uri.cpp
  gu_buffer.cpp
  gu_utils++.cpp
  gu_config.cpp
  gu_fdesc.cpp
  gu_mmap.cpp
  gu_alloc.cpp
  gu_rset.cpp
  gu_resolver.cpp
  gu_histogram.cpp
  gu_signals.cpp
  gu_stats.cpp
  gu_asio.cpp
  gu_asio_datagram.cpp
  gu_asio_stream_engine.cpp
  gu_asio_stream_react.cpp
  gu_debug_sync.cpp
  gu_thread.cpp
  gu_uuid.cpp
  )

# TODO: Warnings should be fixed.
target_compile_options(galerautilsxx
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter)

target_link_libraries(galerautilsxx galerautils ${GALERA_SSL_LIBS})

=== gcomm/src/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

add_library(gcomm
  asio_protonet.cpp
  asio_tcp.cpp
  asio_udp.cpp
  conf.cpp
  defaults.cpp
  datagram.cpp
  evs_consensus.cpp
  evs_input_map2.cpp
  evs_message2.cpp
  evs_node.cpp
  evs_proto.cpp
  gmcast.cpp
  gmcast_proto.cpp
  pc.cpp
  pc_proto.cpp
  protonet.cpp
  protostack.cpp
  transport.cpp
  uuid.cpp
  view.cpp
  socket.cpp
  )

# TODO: Fix these.
target_compile_options(gcomm
  PRIVATE
  -Wno-unused-parameter
  -Wno-conversion
  -Wno-overloaded-virtual
  )

target_link_libraries(gcomm galerautilsxx)

=== gcomm/test/CMakeLists.txt ===
#
# Copyright (C) 2020 Codership Oy <info@codership.com>
#

add_executable(check_gcomm
  check_fair_send_queue.cpp
  check_gcomm.cpp
  check_trace.cpp
  check_types.cpp
  check_util.cpp
  check_evs2.cpp
  check_pc.cpp
  )

target_link_libraries(check_gcomm
  gcomm
  ${GALERA_UNIT_TEST_LIBS}
  )

# TODO: Fix
target_compile_options(check_gcomm
  PRIVATE
  -Wno-conversion
  -Wno-unused-parameter
  -Wno-overloaded-virtual
  )

add_test(
  NAME check_gcomm
  COMMAND check_gcomm
  WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/Testing
  )

#
# Nondeterministic unit tests, must be run manually.
#

add_executable(check_gcomm_nondet
  check_gcomm_nondet.cpp
  check_gmcast.cpp
  check_pc_nondet.cpp
  check_util_nondet.cpp)

target_compile_options(check_gcomm_nondet
  PRIVATE
  -Wno-conversion
  -Wno-overloaded-virtual
  -Wno-unused-parameter
  )

target_link_libraries(check_gcomm_nondet gcomm ${GALERA_UNIT_TEST_LIBS})

#
# Old SSL test, must be run manually.
#

add_executable(ssl_test ssl_test.cpp)

target_compile_options(ssl_test
  PRIVATE
  -Wno-unused-parameter)

target_link_libraries(ssl_test gcomm)

=== debian/control ===
Source: galera-4
Maintainer: Codership Oy <info@codership.com>
Uploaders: Otto Kekäläinen <otto@kekalainen.net>
Section: database
Priority: optional
Standards-Version: 4.5.0
Rules-Requires-Root: no
Build-Depends: check,
               cmake (>= 2.8),
               debhelper (>= 10),
               libasio-dev,
               libboost-dev (>= 1.41),
               libboost-program-options-dev (>= 1.41),
               libssl-dev
Homepage: https://www.galeracluster.com/
Vcs-Git: https://github.com/codership/galera.git
Vcs-Browser: https://github.com/codership/galera

Package: galera-4
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: galera-3,
           garbd-2,
           garbd-3,
           garbd2,
           garbd3,
           percona-galera-3,
           percona-galera-4,
           percona-xtradb-cluster-galera,
           percona-xtradb-cluster-galera-2.x,
           percona-xtradb-cluster-galera-3.x,
           percona-xtradb-cluster-galera-4.x,
           percona-xtradb-cluster-garbd-2.x,
           percona-xtradb-cluster-garbd-3.x,
           percona-xtradb-cluster-garbd-4.x
Breaks: galera
Replaces: galera
Provides: galera,
          galera4,
          percona-xtradb-cluster-galera-26,
          wsrep
Description: Replication framework for transactional applications
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see https://github.com/codership/wsrep-API. For a description
 of Galera replication engine see http://galeracluster.com.
 .
 This package contains the Galera library/plugin.

Package: galera-4-dbg
Architecture: any
Section: debug
Priority: extra
Depends: galera-4 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for galera-4
 This package contains the debugging symbols for galera-4.

Package: galera-arbitrator-4
Architecture: any
Conflicts: galera-arbitrator-3,
           garbd-2,
           garbd2,
           percona-galera-arbitrator-3,
           percona-galera-arbitrator-4,
           percona-xtradb-cluster-garbd-2.x
Breaks: percona-xtradb-cluster-galera-2.x
Replaces: percona-xtradb-cluster-galera-2.x
Depends: lsb-base (>= 3.0-6),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Galera arbitrator daemon
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see https://github.com/codership/wsrep-API. For a description
 of Galera replication engine see http://galeracluster.com.
 .
 This package contains the Galera arbitrator daemon (garbd).

Package: galera-arbitrator-4-dbg
Architecture: any
Section: debug
Priority: extra
Conflicts: percona-xtradb-cluster-galera-2.x-dbg
Depends: galera-arbitrator-4 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for galera-arbitrator-4
 This package contains the debugging symbols for galera-arbitrator-4.
